Index: /trunk/NEMOGCM/ARCH/OLD/arch-ifort_MERCATOR_CLUSTER.fcm
===================================================================
--- /trunk/NEMOGCM/ARCH/OLD/arch-ifort_MERCATOR_CLUSTER.fcm	(revision 5396)
+++ /trunk/NEMOGCM/ARCH/OLD/arch-ifort_MERCATOR_CLUSTER.fcm	(revision 5397)
@@ -16,14 +16,17 @@
 
 %NCDF_INC            -I$NETCDF_INC
-%NCDF_LIB            -L $NETCDF_LIB -lnetcdf
+%NCDF_LIB            -L$NETCDF_LIB -lnetcdff -lnetcdf -L$HDF5_LIB -lhdf5_hl -lhdf5 -lz
+
+%CPP                 cpp
 %FC                  mpif90
-%FCFLAGS             -assume byterecl -convert big_endian -i4 -r8 -O2 -fp-model precise
+%FCFLAGS             -O2 -fp-model precise  -traceback -r8  -convert big_endian -assume byterecl
 %FFLAGS              %FCFLAGS
-%LD                  mpif90
+%LD                   mpif90
 %FPPFLAGS            -P -C -traditional
-%LDFLAGS             -O2 -shared-intel 
+%LDFLAGS             -O2
 %AR                  ar
-%ARFLAGS             -r
+%ARFLAGS             -rs
 %MK                  gmake
-%USER_INC            %NCDF_INC
-%USER_LIB            %NCDF_LIB
+%USER_INC            -I$XIOS_INC %NCDF_INC
+%USER_LIB            -L$XIOS_LIB -lxios %NCDF_LIB -lstdc++
+
Index: /trunk/NEMOGCM/CONFIG/SHARED/namelist_ref
===================================================================
--- /trunk/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 5396)
+++ /trunk/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 5397)
@@ -691,4 +691,10 @@
 &nambbc        !   bottom temperature boundary condition
 !-----------------------------------------------------------------------
+!              !                              !  (if <0  months)  !  
+!              !  file name      ! frequency (hours) ! variable   ! time interp.   !  clim   ! 'yearly'/ ! weights  ! rotation ! land/sea mask !
+!              !                 !  (if <0  months)  !   name     !   (logical)    !  (T/F ) ! 'monthly' ! filename ! pairing  ! filename      !
+   sn_qgh      ='geothermal_heating.nc',  -12.  , 'heatflow'      ,   .false.      , .true.  , 'yearly'  , ''       , ''       , ''
+   !
+   cn_dir      = './'      !  root directory for the location of the runoff files
    ln_trabbc   = .true.    !  Apply a geothermal heating at the ocean bottom
    nn_geoflx   =    2      !  geothermal heat flux: = 0 no flux
@@ -696,4 +702,5 @@
                            !     = 2 variable flux (read in geothermal_heating.nc in mW/m2)
    rn_geoflx_cst = 86.4e-3 !  Constant value of geothermal heat flux [W/m2]
+
 /
 !-----------------------------------------------------------------------
Index: /trunk/NEMOGCM/CONFIG/cfg.txt
===================================================================
--- /trunk/NEMOGCM/CONFIG/cfg.txt	(revision 5396)
+++ /trunk/NEMOGCM/CONFIG/cfg.txt	(revision 5397)
@@ -11,3 +11,8 @@
 ORCA2_LIM OPA_SRC LIM_SRC_2 NST_SRC
 ORCA2_OFF_PISCES OPA_SRC OFF_SRC TOP_SRC
-ORCA2_LIM_OBS OPA_SRC LIM_SRC_2 NST_SRC
+GYRE_LONG OPA_SRC
+GYRE_4 OPA_SRC
+ORCA2OFFPIS_LONG OPA_SRC OFF_SRC TOP_SRC
+ORCA2OFFPIS_16 OPA_SRC OFF_SRC TOP_SRC
+ORCA2LIM3_LONG OPA_SRC LIM_SRC_3 NST_SRC
+ORCA2LIM3_16 OPA_SRC LIM_SRC_3 NST_SRC
Index: /trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90
===================================================================
--- /trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 5396)
+++ /trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 5397)
@@ -21,4 +21,8 @@
    USE trdtra          ! trends manager: tracers 
    USE in_out_manager  ! I/O manager
+   USE iom             ! I/O manager
+   USE fldread         ! read input fields
+   USE lbclnk            ! ocean lateral boundary conditions (or mpp link)
+   USE lib_mpp           ! distributed memory computing library
    USE prtctl          ! Print control
    USE wrk_nemo        ! Memory Allocation
@@ -37,4 +41,5 @@
 
    REAL(wp), PUBLIC, DIMENSION(:,:), ALLOCATABLE ::   qgh_trd0   ! geothermal heating trend
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_qgh              ! structure of input qgh (file informations, fields read)
  
    !! * Substitutions
@@ -92,4 +97,6 @@
       END DO
       !
+      CALL lbc_lnk( tsa(:,:,:,jp_tem) , 'T', 1. )
+      !
       IF( l_trdtra ) THEN        ! Save the geothermal heat flux trend for diagnostics
          ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
@@ -125,6 +132,10 @@
       INTEGER  ::   inum                ! temporary logical unit
       INTEGER  ::   ios                 ! Local integer output status for namelist read
-      !
-      NAMELIST/nambbc/ln_trabbc, nn_geoflx, rn_geoflx_cst 
+      INTEGER  ::   ierror              ! local integer
+      !
+      TYPE(FLD_N)        ::   sn_qgh    ! informations about the geotherm. field to be read
+      CHARACTER(len=256) ::   cn_dir    ! Root directory for location of ssr files
+      !
+      NAMELIST/nambbc/ln_trabbc, nn_geoflx, rn_geoflx_cst, sn_qgh, cn_dir 
       !!----------------------------------------------------------------------
 
@@ -161,8 +172,18 @@
          CASE ( 2 )                          !* variable geothermal heat flux : read the geothermal fluxes in mW/m2
             IF(lwp) WRITE(numout,*) '      *** variable geothermal heat flux'
-            CALL iom_open ( 'geothermal_heating.nc', inum )
-            CALL iom_get  ( inum, jpdom_data, 'heatflow', qgh_trd0 )
-            CALL iom_close( inum )
-            qgh_trd0(:,:) = r1_rau0_rcp * qgh_trd0(:,:) * 1.e-3     ! conversion in W/m2
+            !
+            ALLOCATE( sf_qgh(1), STAT=ierror )
+            IF( ierror > 0 ) THEN
+               CALL ctl_stop( 'tra_bbc_init: unable to allocate sf_qgh structure' )   ;
+               RETURN
+            ENDIF
+            ALLOCATE( sf_qgh(1)%fnow(jpi,jpj,1)   )
+            IF( sn_qgh%ln_tint )ALLOCATE( sf_qgh(1)%fdta(jpi,jpj,1,2) )
+            ! fill sf_chl with sn_chl and control print
+            CALL fld_fill( sf_qgh, (/ sn_qgh /), cn_dir, 'tra_bbc_init',   &
+               &          'bottom temperature boundary condition', 'nambbc' )
+
+            CALL fld_read( nit000, 1, sf_qgh )                         ! Read qgh data
+            qgh_trd0(:,:) = r1_rau0_rcp * sf_qgh(1)%fnow(:,:,1) * 1.e-3 ! conversion in W/m2
             !
          CASE DEFAULT
Index: /trunk/NEMOGCM/SETTE/input_ORCA2_LIM.cfg
===================================================================
--- /trunk/NEMOGCM/SETTE/input_ORCA2_LIM.cfg	(revision 5396)
+++ /trunk/NEMOGCM/SETTE/input_ORCA2_LIM.cfg	(revision 5397)
@@ -1,1 +1,1 @@
-ORCA2_LIM_nemo_v3.6.tar ORCA2_LIM_nemo_v3.6
+ORCA2_LIM_nemo_v3.6.1.tar ORCA2_LIM_nemo_v3.6.1
Index: /trunk/NEMOGCM/SETTE/input_ORCA2_LIM3.cfg
===================================================================
--- /trunk/NEMOGCM/SETTE/input_ORCA2_LIM3.cfg	(revision 5396)
+++ /trunk/NEMOGCM/SETTE/input_ORCA2_LIM3.cfg	(revision 5397)
@@ -1,1 +1,1 @@
-ORCA2_LIM_nemo_v3.6.tar ORCA2_LIM_nemo_v3.6
+ORCA2_LIM_nemo_v3.6.1.tar ORCA2_LIM_nemo_v3.6.1
Index: /trunk/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg
===================================================================
--- /trunk/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg	(revision 5396)
+++ /trunk/NEMOGCM/SETTE/input_ORCA2_LIM_PISCES.cfg	(revision 5397)
@@ -1,1 +1,1 @@
-ORCA2_LIM_nemo_v3.6.tar  ORCA2_LIM_PISCES_v3.6
+ORCA2_LIM_nemo_v3.6.1.tar ORCA2_LIM_nemo_v3.6.1
Index: /trunk/NEMOGCM/SETTE/param.cfg
===================================================================
--- /trunk/NEMOGCM/SETTE/param.cfg	(revision 5396)
+++ /trunk/NEMOGCM/SETTE/param.cfg	(revision 5397)
@@ -1,4 +1,4 @@
 #- forcing files storing 
-FORCING_DIR=/workgpfs/rech/omr/romr006/FORCING
+FORCING_DIR=/data/rd_exchange/cbricaud/INPUT_NEMO
 #- input files storing 
 INPUT_DIR=${CONFIG_DIR}/${NEW_CONF}/EXP00
@@ -6,3 +6,3 @@
 #TMPDIR=${CONFIG_DIR}/${NEW_CONF}/EXP00
 #- VALIDATION files storing 
-NEMO_VALIDATION_DIR=/workgpfs/rech/omr/romr006/NEMO_VALIDATION
+NEMO_VALIDATION_DIR=/data/rd_exchange/cbricaud/NEMOREF_trunk_rev5382/NEMOGCM/SETTE/NEMO_VALIDATION
Index: /trunk/NEMOGCM/SETTE/sette.sh
===================================================================
--- /trunk/NEMOGCM/SETTE/sette.sh	(revision 5396)
+++ /trunk/NEMOGCM/SETTE/sette.sh	(revision 5397)
@@ -88,6 +88,6 @@
 #
 # Compiler among those in NEMOGCM/ARCH
-COMPILER=X64_ADA
-export BATCH_COMMAND_PAR="llsubmit"
+COMPILER=ifort_MERCATOR_CLUSTER
+export BATCH_COMMAND_PAR="qsub"
 export BATCH_COMMAND_SEQ=$BATCH_COMMAND_PAR
 export INTERACT_FLAG="no"
@@ -142,5 +142,6 @@
 # ORCA2_LIM_OBS:   15
 # ORCA2_AGRIF_LIM :16
-for config in  1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
+#for config in  1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
+for config in 1 2 5 6 7 8 
 
 do